module jedec1 [public];
(* $INCLUDE:'TYPE.IBM' *)

{GLOBAL} procedure jedec (var fusemap:fusearray ;
                 var pol_map:polarray ;
                 var pinlist:chip_ptr;
                 var f:text);

const csumlen = 4; (* length of the checksun *)
      stx=2; etx=3; linefeed=10; newline = 13; star = 42;
      blank = 32;
      cubed16 = 4096;

type    csumstr = packed array [1..csumlen] of char;

var msdigits,checksum,i,j : integer;
    temptr:chip_ptr;
    hexchksum : csumstr;
(*********************************************************)

procedure hexconvert (var msd,checksum : integer; var hexchksum :csumstr);

const base = 16;

var i,tempnum : integer;
    hexdata:packed array [1..16] of char;

begin
 hexdata := '0123456789ABCDEF';
 tempnum := (msd mod base) + 1;
 hexchksum[1]:=hexdata[tempnum];
 for i:= 4 downto 2 do
  begin
    tempnum:=(checksum mod base ) + 1;
    hexchksum [i] := hexdata[tempnum];
    checksum:=checksum div base;
  end;
end;
(******************************************************************)
procedure splitchksum (var checksum,msdigits:integer);

begin
 if checksum > cubed16 then
  begin
   msdigits:=msdigits+1;
   checksum := checksum - cubed16;
  end;
end;

begin
checksum:=0;
msdigits:=0;
temptr:=pinlist;
writeln(f,chr(stx));
writeln(f,'PALASM V1.9A - 20RP10');
checksum := checksum + stx + linefeed + newline;
while temptr^.level<>1 do
 begin
  for i:=1 to index do
    begin
     IF temptr^.id_name[i]<>CHR(0) THEN write(f,temptr^.id_name[i]);
     checksum := checksum + ord(temptr^.id_name[i]);
     splitchksum(checksum,msdigits);
    end;
  write (f,'   ');
 checksum:= checksum + 3 * blank;
 splitchksum(checksum,msdigits);
 temptr:=temptr^.rsibling;
 end;
 write(f,chr(star));
 checksum := checksum + star;
 splitchksum(checksum,msdigits);
writeln(f);
checksum:=checksum + linefeed + newline;
splitchksum (checksum,msdigits);
write(f,'QP24*');
checksum:=checksum+ord('Q');
splitchksum(checksum,msdigits);
checksum:=checksum+ord('P');
splitchksum(checksum,msdigits);
checksum:=checksum+ord('2');
splitchksum(checksum,msdigits);
checksum:=checksum+ord('4');
splitchksum(checksum,msdigits);
checksum:=checksum+ord('*');
splitchksum(checksum,msdigits);
write(f,'Q3290*');
checksum:=checksum+ord('Q');
splitchksum(checksum,msdigits);
checksum:=checksum+ord('3');
splitchksum(checksum,msdigits);
checksum:=checksum+ord('2');
splitchksum(checksum,msdigits);
checksum:=checksum+ord('9');
splitchksum(checksum,msdigits);
checksum:=checksum+ord('0');
splitchksum(checksum,msdigits);
checksum:=checksum+ord('*');
splitchksum(checksum,msdigits);
writeln(f);
checksum:=checksum+linefeed;
splitchksum(checksum,msdigits);
checksum:=checksum+newline;
splitchksum(checksum,msdigits);
for i:=1 to 80 do
 begin
  if (i=1)then
   begin
    Write(f,'L');
    checksum:=checksum+ord('L');
    splitchksum(checksum,msdigits);
      write(f,'0');
      checksum:=checksum+ord('0');
      splitchksum(checksum,msdigits);
      write(f,(i-1):1,' ');
      checksum:=checksum+ord(chr(i-1));
      splitchksum(checksum,msdigits);
      checksum:=checksum+blank;
      splitchksum(checksum,msdigits);
   end;
  if (i<>1) (*and (i<>9) and (i<>17)and (i<>25) and (i<>33)and(i<>41)
    and (i<>49) and (i<>57) and (i<>65) and (i<>73)*) then
     begin
      write(f,'    ');
      for j:=1 to 4 do
       begin
        checksum:=checksum+blank;
        splitchksum(checksum,msdigits);
       end;
     end;
  for j:=1 to 40 do
   begin
    if (j=5) or (j=9) or (j=13) or (j=17) or (j=21) or (j=25)
    or (j=29) or (j=33) or (j=37) then
     begin
      write(f,' ');
      checksum:=checksum+blank;
      splitchksum(checksum,msdigits);
     end;
    if (fusemap[i,j]='-') then
     begin
      write(f,'1');
      checksum:=checksum+ord('1');
      splitchksum(checksum,msdigits);
     end
    else
     begin
      write(f,'0');
      checksum:=checksum+ord('0');
      splitchksum(checksum,msdigits);
     end;
    end;
   write(f,' ');
   checksum:=checksum+blank;
   splitchksum(checksum,msdigits);
   if ((i>=1)and(i<=8)) or ((i>=73)and(i<=80)) then
    begin
      if (fusemap[i,41])='x'then
       begin
        write(f,'0');
        checksum:=checksum + ord('0');
        splitchksum(checksum,msdigits);
       end
       else
        begin
         write(f,'1');
         checksum:=checksum+ord('1');
         splitchksum(checksum,msdigits);
        end;
     end
    else
     begin
      for j:=41 to 42 do
       begin
        if fusemap[i,j]='x' then
         begin
          write(f,'0');
          checksum:=checksum+ord('0');
          splitchksum(checksum,msdigits);
         end
        else
         begin
          write(f,'1');
          checksum:=checksum+ord('1');
          splitchksum(checksum,msdigits);
         end;
       end;
    end;
(*   if (i=8) or (i=16) or (i=24) or (i=32) or (i=40) or (i=48)
   or (i=56) or (i=64) or (i=72) or (i=80) then
    begin
     write(f,'*');
     checksum:=checksum+star;
     splitchksum(checksum,msdigits);
    end;*)
  writeln(f);
  checksum:=checksum+linefeed;
  splitchksum(checksum,msdigits);
  checksum:=checksum+newline;
  splitchksum(checksum,msdigits);
 end;
 writeln(f);
 checksum:=checksum+linefeed;
 splitchksum(checksum,msdigits);
 checksum:=checksum+newline;
 splitchksum(checksum,msdigits);
 write(f,'    ');
 checksum:=checksum+ord(' ');
 splitchksum(checksum,msdigits);
 checksum:=checksum+ord(' ');
 splitchksum(checksum,msdigits);
 checksum:=checksum+ord(' ');
 splitchksum(checksum,msdigits);
 checksum:= checksum + blank;
 splitchksum(checksum,msdigits);
 for i:=10 downto 1 do
  begin
   if (pol_map[i]='-') then
    begin
     write(f,'1');
     checksum:=checksum+ord('1');
     splitchksum(checksum,msdigits);
    end
   else
    begin
     write(f,'0');
     checksum:=checksum+ord('0');
     splitchksum(checksum,msdigits);
    end;
  end;
 write(f,'*');
 checksum:=checksum+star;
 splitchksum(checksum,msdigits);
 write(f,chr(etx));
 checksum:=checksum+etx;
 splitchksum(checksum,msdigits);
 for i:=1 to csumlen do hexchksum[i]:=chr(0);
 hexconvert(checksum,msdigits,hexchksum);
 write(f,hexchksum);
end;
end.
;
 for i:=1 to cs